<template>
  <div class="page-table scrollable only-y">
    <div class="">
      <h1>Employers</h1>
      <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->
      <el-breadcrumb separator="/">
        <el-breadcrumb-item :to="{ path: '/' }"><i class="mdi mdi-home-outline"></i></el-breadcrumb-item>
        <el-breadcrumb-item :to="{ path: '/employers' }">Employers</el-breadcrumb-item>
        <el-breadcrumb-item v-if="detail.email">{{detail.email}}</el-breadcrumb-item>

      </el-breadcrumb>

      <add-honey
        :dialogFormvisible.sync="dialogFormvisible"
        rerefreshList
      ></add-honey>
    </div>

    <br />
    <el-card
      v-if="isContentFound"
      style="text-align: left; margin: 20px 0"
      v-loading="loading"
    >
      <not-found></not-found>
    </el-card>
    <div v-else>
      <el-card
        class="box-card"
        style="text-align: left; position: relative"
        v-loading="loading"
      >
        <div class="card-inner p-relative">
          <div class="header-tool">
            <div
              v-if="detail.isActive"
              class="verified-item"
            >
              <span
                class="lbl lbl-success"
                v-if="detail.isActive == 1"
              > Active</span>
              <span
                class="lbl lbl-danger"
                v-if="detail.isActive == 0"
              > Inactive</span>
            </div>
          </div>
          <div class="profile-card">
            <div
              class="left-card"
              style="text-align: center"
            >
              <div class="img-profile">
                <img
                  class="img-full-detail"
                  @click="showAvatar(detail.avatar_url, $event)"
                  :src="(detail.avatar_url)? detail.avatar_url: $store.state.avtHolder"
                >
              </div>
              <h2 style="margin-bottom: 0">{{detail.full_name}}
                <i
                  v-if="detail.gender == 'female'"
                  class="mdi mdi-gender-female"
                ></i>
                <i
                  v-if="detail.gender == 'male'"
                  class="mdi mdi-gender-male"
                ></i>
              </h2>
            </div>
            <div class="right-card">
              <div class="right-card-inner">
                <el-row :gutter="20">
                  <el-col
                    :span="24"
                    v-if="detail.id"
                  >
                    <div
                      class="info-item"
                      title="Employer ID"
                    >
                      <i class="mdi mdi-account-key"></i><span> {{detail.id}}</span>
                    </div>
                  </el-col>
                  <el-col
                    :span="24"
                    v-if="detail.email"
                  >
                    <div
                      class="info-item"
                      title="Email"
                    >
                      <i class="mdi mdi-email-outline"></i><span> {{detail.email}} </span>
                    </div>
                  </el-col>
                  <el-col
                    :span="24"
                    v-if="detail.createDate"
                  >
                    <div
                      class="info-item small"
                      v-if="detail.createDate"
                      title="Created at"
                    >
                      <i class="mdi mdi-calendar-clock"></i><span> {{ detail.createDate | moment("DD-MM-YYYY HH:mm:ss") }}</span>
                    </div>
                  </el-col>
                </el-row>

              </div>

            </div>
          </div>

        </div>
        <div class="profile-bottom flex justify-flex-end">
          <el-button
            type="danger"
            @click="updateStatus(detail.id,0)"
            :disabled="disabledClickable"
            v-if="detail.isActive == 1"
          >Deactivate</el-button>
          <el-button
            type="success"
            @click="updateStatus(detail.id,1)"
            :disabled="disabledClickable"
            v-else-if="detail.isActive == 0"
          >Activate</el-button>
          <div style="margin-left: 10px;">

          </div>
        </div>
      </el-card>

      <view-image
        :dialogvisible.sync="dialogvisible"
        :imageUrl.sync="imageUrl"
      >
      </view-image>
    </div>
  </div>
</template>

<script>
import HoneyLogs from "~/components/dialogs/HoneyLogs"
import ViewImage from "~/components/dialogs/ViewImage";
import AddHoney from "~/components/dialogs/AddHoney";
import $ from 'jquery'
import helper from '~/services/helper'
import users from '@/assets/data/USERS_MOCK_DATA.json'
import {
  employer as employerApi,
  workplace as workplaceAPI

} from '~/services/apis/index'
import NotFound from '../ContentNotFound'
export default {
  name: 'EmployerDetail',
  components: {
    HoneyLogs,
    AddHoney,
    NotFound,
    ViewImage
  },
  data () {
    return {
      detail: {},
      workplaces: [],
      list: users,
      loading: true,
      tableLoading: true,
      currentPage: 1,
      total: 0,
      pageSize: this.$store.state.itemPerPage,
      isContentFound: false,
      dialogvisible: false,
      imageUrl: null,
      dialogFormvisible: false,
      showHoneyLogsDialog: false,
      disabledClickable: false,
      isDeactivated: '',
    }
  },
  methods: {
    getDetail () {
      this.loading = true;
      if (!this.$route || !this.$route.params.id) return;
      employerApi.getEmployer(this.$route.params.id)
        .then((res) => {
          //eslint-disable-next-line
          console.log('res :', res);
          this.detail = res.data
          this.isContentFound = false;
          this.loading = false;
        })
        .catch((err) => {
          this.isContentFound = true;
          this.loading = false;
        })

    },

    initList () {
      this.workplaces.forEach((item, index) => {
        this.$set(this.workplaces[index], 'isVerified', item.verified_at ? true : false)

      })
    },
    onChangePage (page) {
      this.currentPage = this.$helper.formatPage(page)
      //this.$router.push({query: {page: page}})
      this.getWorkplaces();
    },
    showDetail (row) {
      var selection = window.getSelection();
      if (selection.toString().length !== 0) return;

      var id = row.id;
      this.$router.push({        name: 'workplaces_detail', params: { id },
        query: {
          back: "employers",
          back_id: this.$route.params.id,
          employer_name: this.detail.full_name
        }
      });
    },

    formatSalary (from, to) {
      if (!from && !to) {
        return ""
      }
      return "From " + formatNumber(from) + " To " + formatNumber(to);
    },

    updateStatus (row, data) {
      if (data == 0) {
        this.$confirm('Are you sure you want to deactive this user?', 'Warning', {
          confirmButtonText: 'Yes',
          cancelButtonText: 'Cancel',
          type: 'warning',
          center: true
        }).then(() => {
          this.loading = true
          //eslint-disable-next-line
          console.log('row,data :', row, data);
          employerApi.updateStatus(row, { isActive: data }).then(res => {
            if (res.status == 200) {
              this.$notify({
                title: "success",
                message: "Update status user successfully!",
                type: "success"
              });
              this.getDetail()
            }
          }).catch(error => {
            this.$notify({
              title: "Error",
              message: "Cannot update status user!",
              type: "error"
            });
            this.loading = false
          })
        }).catch(error => {

        })
      } else if (data == 1) {
        this.loading = true
        //eslint-disable-next-line
        console.log('row,data :', row, data);
        employerApi.updateStatus(row, { isActive: data }).then(res => {
          if (res.status == 200) {
            this.$notify({
              title: "success",
              message: "Update status user successfully!",
              type: "success"
            });
          }
        }).catch(error => {
          this.$notify({
            title: "Error",
            message: "Cannot update status user!",
            type: "error"
          });
          this.loading = false
        })
      }
    },
    showAvatar (url, event) {
      if (event) {
        event.preventDefault();
        event.stopPropagation();
      }

      if (!url) return;
      this.imageUrl = url;
      this.dialogvisible = true;
    },
    onEdit () {
      this.$router.push({ name: 'employers_edit' });
    },
    handleActionClick (value) {
      if (!value) {
        this.$confirm('Are you sure you want to deactivate this account ?', 'Warning', {
          confirmButtonText: 'OK',
          cancelButtonText: 'Cancel',
          type: 'warning',
          center: true
        }).then(res => {
          this.handleActivateEmployer(value)
        }).catch((err) => {
        })
      } else {
        this.handleActivateEmployer(value)
      }

    },
    handleActivateEmployer (value) {
      this.disabledClickable = true
      let message = value ? 'Activate' : 'Deactivate'
      employerApi.isActivate(this.$route.params.id, value)
        .then(res => {
          if (res.data.success) {
            this.$notify({
              title: "Success",
              message: `${message} successfully!`,
              type: "success"
            });
          }
          this.isDeactivated = value;
          setTimeout(() => {
            this.disabledClickable = false;
          }, 1000)
        })
        .catch(err => {
          this.$notify({
            title: "Error",
            message: `${message} failed!`,
            type: "error"
          });
          this.disabledClickable = false;
        })
    }

  },
  mounted () {
    this.getDetail()
  }
}
</script>

<style lang="scss">
.btn-verify {
  position: absolute;
  top: 10px;
  right: 10px;
}

.profile-card {
  & > div {
    display: inline-block;
    vertical-align: top;
  }
  .left-card {
    width: 250px;
    padding: 20px 0;
  }
  .right-card {
    width: calc(100% - 250px);
    .right-card-inner {
      padding: 20px;
    }
  }
}
.btn-eye {
  padding: 1px 6px;
}

.profile-bottom {
  width: 100%;
  padding-top: 25px;
  border-top: 1px solid #f1f1f1;
}

.add-honey-button {
  float: right;
}
</style>
